//neural.h
//public functions for the implementation of a recurrent neural
//network


#ifndef NEURAL_H
#define NEURAL_H 1
void niterate(double* output, double* input, double** wts, long n, long m, double s);
double lyapunov(long n, long m, double s, double** wts, long iters);
inline double distanceN(double* vector1,double* vector2, long n);
inline double error(double** array1, double** array2, int width, int height);
double train(double** tset, double** wts, int n, int m, double s, double old_error, int tlength, double& temp, double cooldown);
int save(double** wts, int n, int m, double s, char* filename, char* header=NULL);
int load(double** wts, int n, int m, char* filename, char* header=NULL);
int trainonfile(char* trainfilename, char* netfilename, char* outfilename,  
				 int n, int m, double s, long goal_improvements, 
				 long run_freq, long run_len, double& error);
void gensineset(char* filename, int n, int tlength);






#endif
